#!/bin/bash

. "$(dirname $0)/calendar_exec.sh"

FINISH_FLAG="$BACKUPDIR/.finish_flag"

loopCmd () {
	i=1
	while true
	do
	  #CMD="${PHP} ${CMD_ABSOLUTE_PATH}/calendar_exec.php -m backup -M ${BACKUP_EXPORT_STEP} -p ${i} $1"
	  #( $CMD; [ $? != 8 ] && echo 1 > "$FINISH_FLAG" ) & >/dev/null
	  echo "Backup [$2 calendar] [page $i]"
	  ( ${PHP} ${CMD_ABSOLUTE_PATH}/calendar_exec.php -m backup -M ${BACKUP_EXPORT_STEP} -p ${i} $1; [ $? != 8 ] && echo 1 > "$FINISH_FLAG" ) & >/dev/null
	  
	  while [ $(jobs|grep Running|wc -l) -ge $MAX_CONCURRENT_PROCESS ]
	  do
	    sleep 2
	  done
	  
	  [ -e "$FINISH_FLAG" ] && break
	  #[ $i == 500 ] && echo "INFINiTE LOOP DETECTEd" && break
	  
	  i=$(($i + 1))
	done
}

tgzYesterday () {
    YBACKUPDIR=$(readOBMIni backupRoot)
	YBACKUPDIR="$YBACKUPDIR/$(date $BACKUP_DATE_FORMAT -d yesterday)"
	
	if [ -e "$YBACKUPDIR" ]
	then
		tar czf "$YBACKUPDIR.tar.gz" "$YBACKUPDIR"
		rm -R "$YBACKUPDIR"
	fi
}


pushd $(dirname $0) > /dev/null
	MAX_CONCURRENT_PROCESS=$(readOBMIni maxConcurrentProcess)
	[ "$MAX_CONCURRENT_PROCESS" == "" ] && MAX_CONCURRENT_PROCESS=3
	
	BACKUP_EXPORT_STEP=$(readOBMIni backupExportStep)
	[ "$BACKUP_EXPORT_STEP" == "" ] && BACKUP_EXPORT_STEP=300

    [ -e "$FINISH_FLAG" ] && rm "$FINISH_FLAG"
	loopCmd export users
	
    [ -e "$FINISH_FLAG" ] && rm "$FINISH_FLAG"
	loopCmd export_resources resources
	
	wait
	
	tgzYesterday
popd > /dev/null
