#!/bin/bash

OBM_PATH=../..
OBM_CONF=${OBM_PATH}/conf

# Lit le fichier de configuration global obm_conf.ini
# Code repris du fichier www/scripts/2.4/install_db_2.4.sh d'Aliamin
readOBMIni () {
   #echo Recherche $1 1>&2
   VALUE=$(grep ^$1\ *= "${OBM_CONF}/obm_conf.ini" | cut -d= -f2 | tr -d '^ ' | tr -d '" ')
   echo $VALUE
}

getPHP () {
	# We search for PHP interpreter (different name on Debian, RedHat, Mandrake)
	PHP=`which php4 2> /dev/null`
	if [ $? != 0 ]; then
	  PHP=`which php 2> /dev/null`
	  if [ $? != 0 ]; then
	    PHP=`which php-cgi 2> /dev/null`
	    [ $? != 0 ] && exit 1
	  fi
	fi
	
	echo $PHP
}

PHP="$(getPHP) -d include_path=.:${OBM_PATH}/ -d max_execution_time=0 -d memory_limit=512M "
[ $? != 0 ] && echo "Can't find php interpreter" && exit 1 >&2

pushd $(dirname $0) > /dev/null

    CMD_ABSOLUTE_PATH=$(pwd)
    
	BACKUP_DATE_FORMAT=$(readOBMIni backupDateFormat)
	[ "$BACKUP_DATE_FORMAT" == "" ] && BACKUP_DATE_FORMAT="+%Y%m%d"
    
    if [ "$BACKUPDIR" == "" ]
    then
        BACKUPDIR=$(readOBMIni backupRoot)
        [ ! -e "${OBM_CONF}/obm_conf.ini" ] && echo "Fatal error: ${OBM_CONF}/obm_conf.ini not found" && exit 1 >&2
        [ "$BACKUPDIR" == "" ] && echo "Fatal error: no backupRoot parameter found in ${OBM_CONF}/obm_conf.ini" && exit 1 >&2
	    BACKUPDIR="${BACKUPDIR}/$(date "$BACKUP_DATE_FORMAT")"
	    [ ! -e "$BACKUPDIR" ] && mkdir -p "$BACKUPDIR"
	    export BACKUPDIR
	fi
	
popd > /dev/null


if [ $(basename $0) == "calendar_exec.sh" ]
then
	EXIT_CODE=0
	pushd "$(dirname $0)" > /dev/null
	
		pushd ${OBM_PATH}/php/calendar > /dev/null
		
			#echo ${PHP} "${CMD_ABSOLUTE_PATH}/calendar_exec.php" "$@"
			${PHP} "${CMD_ABSOLUTE_PATH}/calendar_exec.php" "$@"
			EXIT_CODE=$?
			
		popd > /dev/null
		
	popd > /dev/null
	
	exit $EXIT_CODE
fi
