#!/bin/bash
# Copyright (C) 2008 Linagora Group.
#
# Authors:  Xavier Lamien <xlamien@linagora.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


obmconf=/etc/obm/obm-rpm.conf
MYSQL_SQL=`rpm -qa |grep obm-MySQL | cut -d"-" -f1-3`

. ${obmconf}

DB="MySQL"
# Check if MySQL server is running
#check mysql-server status
/sbin/service mysqld status %2>/dev/null	
if [ "$?" -gt "0" ] ; then
	/sbin/service mysqld start %2>/dev/null
fi
echo -e "Enter MySQL root Password : \c"
echo -e "\r"
stty -echo
read passwd
stty echo
if [ -z ${passwd} ] ; then
	MYSQL_CMD="/usr/bin/mysql -h ${OBM_HOST}"
else
	MYSQL_CMD="/usr/bin/mysql -h ${OBM_HOST} -u root -p$passwd"
fi

# Check if database already exist
CHECKDB=`${MYSQL_CMD} -e "SHOW DATABASES"| grep ^${OBM_DBNAME}$`
if [ "$CHECKDB" = "${OBM_DBNAME}" ] ; then
	echo "DataBase ${OBM_DBNAME} already exist"
	echo -e "Would you like to overise ${OBM_DBNAME} DataBase, (y)es (n)o ?: \c"
	read answear
        if [ ${answear} = "y" -o ${answear} = "yes" ] ; then
        	# Drop present database (outch!)
                $MYSQL_CMD -e "DROP DATABASE ${OBM_DBNAME}"
	else
		echo -e "\n"
		echo "So then, choose another Database name in obm-config package before continue."
		exit 0
	fi
fi

# Create DataBase 
$MYSQL_CMD -e "CREATE DATABASE ${OBM_DBNAME}"
# Add user to DataBase
$MYSQL_CMD -e "GRANT ALL PRIVILEGES ON ${OBM_DBNAME}.* TO '${OBM_DBUSER}'@'${OBM_HOST}' IDENTIFIED BY '$OBM_PASSWD' WITH GRANT OPTION"
	
echo -e "--> Installing sql schemas into DataBase....\n"
echo -e "\n"
sleep 2
$MYSQL_CMD ${OBM_DBNAME} < /usr/share/doc/$MYSQL_SQL/mysql.sql

