%define bname	obm

Name:           obm-core
Version:        2.1.10
Release:        1%{?dist}
Summary:        Open Business Management

Group:          Development/Languages
License:        GPLv2
URL:            http://obm.aliasource.fr
Source0:        http://obm.aliasource.fr/obm-archives/%{bname}-%{version}.tar.gz
Source1:        %{bname}-httpd.conf
Source2:        %{bname}-config.sh
Source3:	mysql.sql
source4:	obm-core.cron.d
Source5:	%{bname}-core.sh
Source6:	%{bname}-mysql.sh
Source7:	%{bname}-admin.sh
Source8:	%{bname}-ldap.sh
Source9:	%{bname}-satellite.sh
#Patch0:		config_update_tools.patch
#Patch1:		config_update_tools_admin0.patch
#Patch2:		set_images_path_according_to_link.patch
BuildRoot:      %{_tmppath}/%{bname}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildARch:      noarch
BuildRequires:  usermode
Provides:	obm
Requires: 	php >= 5, php-xml, php-mysql, php-gd
Requires:       %{bname}-config = %{version}-%{release}
Requires(post):	vixie-cron


%description
OBM is a global Groupware, Messaging, CRM and Project appliation.
It is mainly used as an Exchange Or Notes/Domino Mail and groupware replacement
but also as simple contact databases to full CRM.
OBM advanced shared calendar and contacts has connectors with MS Outlook,
Thunderbird/Lightning or PDA.

%package	-n %{bname}-config
Summary:	OBM common configuration
Group:		Development/Tools

%description	-n %{bname}-config
The %{bname}-config package contains OBM configuration files
for %{bname} related packages.

%package	-n %{bname}-MySQL
Summary:	MySQL common files for OBM
Group:		Development/Tools

Requires:	%{bname}-core = %{version}-%{release}
Requires:       %{bname} = %{version}-%{release}
Requires:	mysql-server >= 5.0

%description	-n %{bname}-MySQL
The %{bname}-MySQL package contains MySQL schemes and configuration
file for %{bname} package.

%package        -n %{bname}-ui
Summary:        apache2 configuration for OBM
Group:          Development/Tools

Requires:       %{bname}-core = %{version}-%{release}
Requires(pre):  httpd

%description    -n %{bname}-ui
The %{bname}-ui package configure Apache OBM
file for %{bname} package.

%package	-n %{bname}-services
Summary:	OBM script to manage services
Group:		Development/Tools

Requires:	%{bname}-config = %{version}-%{release}
Requires:	perl-OBM = %{version}-%{release}

%description	-n %{bname}-services
The %{bname}-services package contains perl script to manage services.

%package	-n perl-OBM
Summary:	Perl libraries for OBM
Group:		Development/Libraries
License:        GPL+ or Artistic

BuildARch:      noarch
BuildRequires:	perl(ExtUtils::MakeMaker)
Requires:	perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%description	-n perl-OBM
perl-OBM package contains OBM libs for perl

%package	-n perl-ObmSatellite
Summary:        Perl libraries for OBM-Satellite
Group:          Development/Libraries
License:        GPL+ or Artistic

BuildARch:	noarch
BuildRequires:  perl(ExtUtils::MakeMaker)
Requires:       perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%description    -n perl-ObmSatellite
perl-ObmSatellite package contains OBM-Satellite libraries for perl


%package	-n %{bname}-ldap
Summary:	OBM ldap configuration
Group:		Development/Tools

Requires:	%{bname}-config = %{version}-%{release}
Requires:	openldap-servers

%description	-n %{bname}-ldap
Configuration of OpenLDAP

%package        -n %{bname}-Satellite
Summary:        OBM Satellite configuration
Group:          Development/Tools

Requires:       %{bname}-config = %{version}-%{release}
Requires:	perl-ObmSatellite = %{version}-%{release}
Requires(post):	chkconfig
Requires(preun):chkconfig
Requires(preun):initscripts

%description    -n %{bname}-Satellite
The package %{bname}-Satellite contains satellite configuration
files for OBM.




%prep
%setup -q -n %{bname}-%{version} 

#%patch0 -p1
#%patch1 -p1
#%patch2 -p1

cp %{SOURCE3} .
touch obm-rpm.conf

# Add default config
#%patch0 -p1 -b .conf
mv conf/obm_conf.inc.sample conf/obm_conf.inc
mv conf/obm_conf.ini.sample conf/obm_conf.ini

# Fix encoding, excluded sql schemas for now to avoid trouble interact
for file in `ls scripts/2.1/*.txt` `ls doc/*/*/*.txt`; do
	iconv -f ISO88591 -t UTF-8 $file -o file.tmp
	mv file.tmp $file
done

%build
pushd auto/libperl-OBM
perl Makefile.PL INSTALLDIRS=vendor
cd ../libperl-ObmSatellite
perl Makefile.PL INSTALLDIRS=vendor
popd

%install
#ALL
rm -rf $RPM_BUILD_ROOT

#libperl stuff
mkdir -p $RPM_BUILD_ROOT%{perl_vendorlib}
pushd auto/libperl-OBM
make install PERL_INSTALL_ROOT=$RPM_BUILD_ROOT
cd ../libperl-ObmSatellite
make install PERL_INSTALL_ROOT=$RPM_BUILD_ROOT
popd

#Remove unneeded stuff
find $RPM_BUILD_ROOT -type f -name .packlist -exec rm -f {} ';'

#obm-config
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/%{bname}
install -p -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_bindir}/%{bname}-config
install -p -m 755 %{SOURCE7} $RPM_BUILD_ROOT%{_bindir}/%{bname}-admin
cp conf/obm_conf.ini $RPM_BUILD_ROOT%{_sysconfdir}/%{bname}
#ghost stuff
touch $RPM_BUILD_ROOT%{_sysconfdir}/%{bname}/%{bname}-rpm.conf


#obm-core
install -p -m 755 %{SOURCE5} $RPM_BUILD_ROOT%{_bindir}/%{bname}-core
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/%{bname}/modules
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/%{bname}/themes/images
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/obm/backup
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/obm/documents/0
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/obm/documents/1
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/obm/documents/2
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/obm/documents/3
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/obm/documents/4
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/obm/documents/5
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/obm/documents/6
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/obm/documents/7
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/obm/documents/8
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/obm/documents/9
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{bname}

cp -apR contrib cron obminclude php resources tests scripts \
	$RPM_BUILD_ROOT%{_datadir}/%{bname}
cp conf/obm_conf.inc $RPM_BUILD_ROOT%{_sysconfdir}/%{bname}
# Fix permissions
chmod 0664 \
	$RPM_BUILD_ROOT%{_datadir}/%{bname}/php/admin_code/admin_code_index.php \
	$RPM_BUILD_ROOT%{_datadir}/%{bname}/php/admin_lang/admin_lang_index.php \
	$RPM_BUILD_ROOT%{_datadir}/%{bname}/cron/Logger.class.php \
	$RPM_BUILD_ROOT%{_datadir}/%{bname}/php/time/time_index.php \
	$RPM_BUILD_ROOT%{_datadir}/%{bname}/php/time/*.inc \
	$RPM_BUILD_ROOT%{_datadir}/%{bname}/resources/*/*/*/*.css \
	$RPM_BUILD_ROOT%{_datadir}/%{bname}/resources/*/*/*.inc \
	$RPM_BUILD_ROOT%{_datadir}/%{bname}/%{bname}include/*/of_session.inc

ln -s %{_datadir}/%{bname}/php/resources $RPM_BUILD_ROOT%{_datadir}/%{bname}/php/images

pushd $RPM_BUILD_ROOT%{_sysconfdir}
ln -s %{_sysconfdir}/%{bname} $RPM_BUILD_ROOT%{_datadir}/%{bname}/conf
popd
mkdir $RPM_BUILD_ROOT%{_sysconfdir}/cron.d/
install -p -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/cron.d/obm-core

cp conf/modules/module.inc $RPM_BUILD_ROOT%{_sysconfdir}/%{bname}/modules
cp conf/themes/login.html.sample $RPM_BUILD_ROOT%{_sysconfdir}/%{bname}/themes


#obm-ui
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/%{bname}.conf
#install -p -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_datadir}/%{bname}/install.db
#install -p -m 644 %{SOURCE6} $RPM_BUILD_ROOT%{_datadir}/%{bname}/config.db
#install -Dm 644 %{SOURCE3} $RPM_BUILD_ROOT/%{_sysconfdir}/pam.d/%{bname}
#install -Dm 644 %{SOURCE4} $RPM_BUILD_ROOT/%{_sysconfdir}/security/console.apps/%{bname}


# obm-MySQL
install -p -m 755 %{SOURCE6} $RPM_BUILD_ROOT%{_bindir}/%{bname}-mysql

# obm-services
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{bname}/auto
cp -apR auto/testObmSatellite.pl $RPM_BUILD_ROOT%{_datadir}/%{bname}/auto
cp -apR auto/updateCyrusAcl.pl $RPM_BUILD_ROOT%{_datadir}/%{bname}/auto
cp -apR auto/update.pl $RPM_BUILD_ROOT%{_datadir}/%{bname}/auto
cp -apR auto/updateSieve.pl $RPM_BUILD_ROOT%{_datadir}/%{bname}/auto
cp -apR auto/changePasswd.pl $RPM_BUILD_ROOT%{_datadir}/%{bname}/auto
#FIXME# Pas de lien symbolique de incrementalUpdate.pl vers update.pl

# obm-ldap
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/openldap/schema
install -p -m 644 doc/conf/ldap_samba.schema.3.0.24.sample $RPM_BUILD_ROOT%{_sysconfdir}/openldap/schema/samba.schema
install -p -m 644 doc/conf/ldap_obm.schema.sample $RPM_BUILD_ROOT%{_sysconfdir}/openldap/schema/obm.schema
install -p -m 755 %{SOURCE8} $RPM_BUILD_ROOT%{_bindir}/%{bname}-ldap

# obm-stallite stuff
mkdir -p $RPM_BUILD_ROOT%{_datadir}/obm-satellite
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/init.d
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/%{bname}-satellite
install -p -m 755 %{SOURCE9} $RPM_BUILD_ROOT%{_bindir}/%{bname}-satellite
install -p -m 644 auto/obmSatellite/obmSatellite.pl $RPM_BUILD_ROOT%{_datadir}/obm-satellite
install -p -m 755 auto/obmSatellite/init-obmSatellite.sample $RPM_BUILD_ROOT%{_sysconfdir}/init.d/obmSatellite
install -p -m 644 auto/obmSatellite/obmSatellite.cf.sample $RPM_BUILD_ROOT%{_sysconfdir}/%{bname}-satellite/%{bname}Satellite.cf
pushd $RPM_BUILD_ROOT%{_sysconfdir}/%{bname}-satellite/
ln -s ./%{bname}Satellite.cf $RPM_BUILD_ROOT%{_datadir}/obm-satellite/%{bname}Satellite.cf
popd

# Add self auth on wrapper script
#ln -sf consolehelper $RPM_BUILD_ROOT%{_bindir}/%{bname}-config

# Remove version-controle-internal file ---> useless
find $RPM_BUILD_ROOT -name '.cvsignore' -exec rm -rf {} ';'

%clean
rm -rf $RPM_BUILD_ROOT


%post		-n %{bname}-MySQL
# Set DB type
sed -i "s|$(egrep '^dbtype =' %{_datadir}/%{bname}/conf/obm_conf.ini)|dbtype = MYSQL|g" \
	%{_sysconfdir}/%{bname}/obm_conf.ini


%post		-n %{bname}-Satellite
/sbin/chkconfig --add obmSatellite

%preun		-n %{bname}-Satellite
if [ $1 = 0 ] ; then
/sbin/service obmSatellite stop >/dev/null 2>&1
/sbin/chkconfig --del obmSatellite
fi



%files
%{_bindir}/%{bname}-core
%defattr(-,root,root,-)
%doc doc/* COPYING README Release-notes.txt
%attr(-,apache,apache) %dir %{_datadir}/%{bname}
%attr(-,apache,apache) %dir %{_localstatedir}/lib/%{bname}
%attr(-,apache,apache) %dir %{_localstatedir}/lib/%{bname}/backup
%attr(-,apache,apache) %dir %{_localstatedir}/lib/%{bname}/documents
%attr(-,apache,apache) %dir %{_localstatedir}/lib/%{bname}/documents/0
%attr(-,apache,apache) %dir %{_localstatedir}/lib/%{bname}/documents/1
%attr(-,apache,apache) %dir %{_localstatedir}/lib/%{bname}/documents/2
%attr(-,apache,apache) %dir %{_localstatedir}/lib/%{bname}/documents/3
%attr(-,apache,apache) %dir %{_localstatedir}/lib/%{bname}/documents/4
%attr(-,apache,apache) %dir %{_localstatedir}/lib/%{bname}/documents/5
%attr(-,apache,apache) %dir %{_localstatedir}/lib/%{bname}/documents/6
%attr(-,apache,apache) %dir %{_localstatedir}/lib/%{bname}/documents/7
%attr(-,apache,apache) %dir %{_localstatedir}/lib/%{bname}/documents/8
%attr(-,apache,apache) %dir %{_localstatedir}/lib/%{bname}/documents/9
%{_datadir}/%{bname}/conf
%{_datadir}/%{bname}/contrib
%{_datadir}/%{bname}/cron
%{_datadir}/%{bname}/obminclude
%{_datadir}/%{bname}/php
%{_datadir}/%{bname}/resources
%{_datadir}/%{bname}/tests
%{_datadir}/%{bname}/scripts
%{_sysconfdir}/%{bname}
%{_sysconfdir}/cron.d/obm-core

%files		-n perl-OBM
%defattr(-,root,root,-)
%{perl_vendorlib}/OBM
%{_mandir}/man3/*.3pm*

%files          -n perl-ObmSatellite
%defattr(-,root,root,-)
%{perl_vendorlib}/ObmSatellite

%files		-n %{bname}-ui
%config(noreplace) %{_sysconfdir}/httpd/conf.d/*.conf


%files		-n %{bname}-config
%defattr(-,root,root,-)
%{_bindir}/%{bname}-config
%{_bindir}/%{bname}-admin
%dir %{_sysconfdir}/%{bname}
%config(noreplace) %{_sysconfdir}/%{bname}/%{bname}_conf.ini
%ghost %{_sysconfdir}/%{bname}/%{bname}-rpm.conf
#%config(noreplace) %{_sysconfdir}/pam.d/%{bname}
#%config(noreplace) %{_sysconfdir}/security/console.apps/%{bname}

%files		-n %{bname}-MySQL
%defattr(-,root,root,-)
%doc mysql.sql
%{_bindir}/%{bname}-mysql


%files		-n %{bname}-services
%{_datadir}/%{bname}/auto

%files 		-n %{bname}-ldap
%{_bindir}/%{bname}-ldap
%doc doc/conf/ldap_slapd.conf.sample.rpm
%{_sysconfdir}/openldap/schema/obm.schema
%{_sysconfdir}/openldap/schema/samba.schema

%files		-n %{bname}-Satellite
%defattr(-,root,root,-)
%{_bindir}/%{bname}-satellite
%{_datadir}/%{bname}-satellite
%{_sysconfdir}/%{bname}-satellite/%{bname}Satellite.cf
%{_sysconfdir}/init.d/obmSatellite
#files		-n %{bname}-PostgreSQL
#%defattr(-,root,root,-)
#%doc scripts/2.1/create_obmdb_2.1.pgsql.sql

#%files		-n %{bname}-services
#%defattr(-,root,root,-)
#%{_datadir}/%{bname}/auto


%changelog
* Mon Apr 21 2008 Xavier Lamien <lxtnow[at]gmail.com> - 2.1.9-1
- Initial RPM Release.
